import { ValidationArguments } from 'class-validator';
import { Frequency } from '../../types/frequency.enum';

const isPunctual = (args: ValidationArguments): boolean =>
  args.object['frequency'] === Frequency.PUNCTUAL &&
  args.object['departure'] instanceof Date &&
  !Object.keys(args.object['schedule']).length;

const isRecurrent = (args: ValidationArguments): boolean =>
  args.object['frequency'] === Frequency.RECURRENT &&
  args.object['fromDate'] instanceof Date &&
  args.object['toDate'] instanceof Date &&
  Object.keys(args.object['schedule']).length > 0;

export const isPunctualOrRecurrent = (args: ValidationArguments): boolean =>
  isPunctual(args) || isRecurrent(args);
