import { hasProperDriverSeats } from '../../../domain/dtos/validators/has-driver-seats';

describe('driver and/or driver seats validator', () => {
  it('should validate if driver and drivers seats is not provided ', () => {
    expect(
      hasProperDriverSeats({
        value: undefined,
        constraints: [],
        targetName: '',
        object: { driver: undefined },
        property: '',
      }),
    ).toBe(true);
    expect(
      hasProperDriverSeats({
        value: undefined,
        constraints: [],
        targetName: '',
        object: { driver: false },
        property: '',
      }),
    ).toBe(true);
    expect(
      hasProperDriverSeats({
        value: undefined,
        constraints: [],
        targetName: '',
        object: { driver: null },
        property: '',
      }),
    ).toBe(true);
  });
  it('should not validate if driver is set to true but not the related seats is not provided or 0', () => {
    expect(
      hasProperDriverSeats({
        value: undefined,
        constraints: [],
        targetName: '',
        object: { driver: true },
        property: '',
      }),
    ).toBe(false);
    expect(
      hasProperDriverSeats({
        value: undefined,
        constraints: [],
        targetName: '',
        object: { driver: true, seatsDriver: 0 },
        property: '',
      }),
    ).toBe(false);
    expect(
      hasProperDriverSeats({
        value: undefined,
        constraints: [],
        targetName: '',
        object: { driver: true, seatsDriver: undefined },
        property: '',
      }),
    ).toBe(false);
    expect(
      hasProperDriverSeats({
        value: undefined,
        constraints: [],
        targetName: '',
        object: { driver: true, seatsDriver: null },
        property: '',
      }),
    ).toBe(false);
  });
  it('should not validate if driver seats are provided but driver is not set or set to false ', () => {
    expect(
      hasProperDriverSeats({
        value: undefined,
        constraints: [],
        targetName: '',
        object: { driver: false, seatsDriver: 1 },
        property: '',
      }),
    ).toBe(false);
    expect(
      hasProperDriverSeats({
        value: undefined,
        constraints: [],
        targetName: '',
        object: { driver: undefined, seatsDriver: 1 },
        property: '',
      }),
    ).toBe(false);
    expect(
      hasProperDriverSeats({
        value: undefined,
        constraints: [],
        targetName: '',
        object: { driver: null, seatsDriver: 1 },
        property: '',
      }),
    ).toBe(false);
  });
});
